import contextlib
import unittest
import io
import unittest.mock
from unittest import TextTestRunner

class MainTest(unittest.TestCase):

    def test_answer(self):

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        bot8(0.05, 0.8, 0.01)
        sys.stdout = sys.__stdout__ 
        output = capturedOutput.getvalue().strip()
        self.assertEqual(output, '0.8080808080808081', "Incorrect answer. Please check your calculations.")

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        bot8(0.0, 0.8, 0.01)
        sys.stdout = sys.__stdout__ 
        output = capturedOutput.getvalue().strip()
        self.assertEqual(output, '0.0', "Incorrect answer. Please check your calculations.")

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        bot8(0.05, 0.1, 0.1)
        sys.stdout = sys.__stdout__ 
        output = capturedOutput.getvalue().strip()
        self.assertEqual(output, '0.05000000000000001', "Incorrect answer. Please check your calculations.")

        capturedOutput = io.StringIO()                 
        sys.stdout = capturedOutput                     
        bot8(0.05, 0.1, 0.0)
        sys.stdout = sys.__stdout__ 
        output = capturedOutput.getvalue().strip()
        self.assertEqual(output, '1.0', "Incorrect answer. Please check your calculations.")

test_suite = unittest.TestLoader().loadTestsFromTestCase(MainTest)
with io.StringIO() as buf:
    # run the tests
    with contextlib.redirect_stdout(buf):
        TextTestRunner(stream=buf).run(test_suite)
    # process (in this case: print) the results
    printTest(buf.getvalue())